[inherit('common')]
module xmlrpc_parse(input, output);

[external]
function xmlrpc_response(%immed xmlstr : c_str_t; %immed res : integer) : integer; external;

[external]
function xmlrpc_response_status(%immed xmlstr : c_str_t) : integer; external;

[external]
function xmlrpc_response_errmsg(%immed xmlstr : c_str_t; %ref errcod : integer; %ref errmsg : c_str_t) : integer; external;

type
    xmlrpc_struct_t = integer;

[external]
function xmlrpc_struct_init(%immed xmlstr : c_str_t; %immed nfld : integer) : xmlrpc_struct_t; external;

[external]
function xmlrpc_struct_n(%immed ctx : xmlrpc_struct_t) : integer; external;

[external]
function xmlrpc_struct_unpack_i4(%immed ctx : xmlrpc_struct_t; %immed ix : integer; %immed name : c_str_t) : integer; external;

[external]
function xmlrpc_struct_unpack_string(%immed ctx : xmlrpc_struct_t; %immed ix : integer; %immed name : c_str_t) : c_str_t; external;

[external]
procedure xmlrpc_struct_cleanup(%immed ctx : xmlrpc_struct_t); external;

function pxmlrpc_response(xmlstr : pstr; res : integer) : integer;

var
   xmlstr2 : c_str_t;

begin
   xmlstr2 := malloc_c_str(xmlstr);
   pxmlrpc_response := xmlrpc_response(xmlstr2, res);
   free_c_str(xmlstr2);
end;

function pxmlrpc_response_status(xmlstr : pstr) : boolean;

var
   xmlstr2 : c_str_t;

begin
   xmlstr2 := malloc_c_str(xmlstr);
   pxmlrpc_response_status := (xmlrpc_response_status(xmlstr2) <> 0);
   free_c_str(xmlstr2);
end;

function pxmlrpc_response_errmsg(xmlstr : pstr; var errcod : integer; var errmsg : pstr) : integer; 

var
   xmlstr2 : c_str_t;
   errmsg2 : c_str_t;
   res : integer;

begin
    xmlstr2 := malloc_c_str(xmlstr);
    pxmlrpc_response_errmsg := xmlrpc_response_errmsg(xmlstr2, errcod, errmsg2);
    free_c_str(xmlstr2);
    errmsg := pas_str(errmsg2);
end;

function pxmlrpc_struct_init(xmlstr : pstr; nfld : integer) : integer;

var
   xmlstr2 : c_str_t;

begin
   xmlstr2 := malloc_c_str(xmlstr);
   pxmlrpc_struct_init := xmlrpc_struct_init(xmlstr2, nfld);
end;

function pxmlrpc_struct_n(ctx : xmlrpc_struct_t) : integer;

begin
   pxmlrpc_struct_n := xmlrpc_struct_n(ctx);
end;

function pxmlrpc_struct_unpack_i4(ctx : xmlrpc_struct_t; ix : integer; name : pstr) : integer;

var
   name2 : c_str_t;

begin
   name2 := malloc_c_str(name);
   pxmlrpc_struct_unpack_i4 := xmlrpc_struct_unpack_i4(ctx, ix, name2);
   free_c_str(name2);
end;

function pxmlrpc_struct_unpack_string(ctx : xmlrpc_struct_t; ix : integer; name : pstr) : pstr;

var
   name2 : c_str_t;

begin
   name2 := malloc_c_str(name);
   pxmlrpc_struct_unpack_string := pas_str(xmlrpc_struct_unpack_string(ctx, ix, name2));
   free_c_str(name2);
end;

procedure pxmlrpc_struct_cleanup(ctx : xmlrpc_struct_t);

begin
   xmlrpc_struct_cleanup(ctx);
end;

end.
